# Class ConfigTestElement

java.lang.Object
org.apache.jmeter.testelement.AbstractTestElement
org.apache.jmeter.config.ConfigTestElement

All Implemented Interfaces:
  `Serializable, Cloneable, ConfigElement, Searchable, TestElement`

Direct Known Subclasses:
  `Arguments, AuthManager, CacheManager, CookieManager, CSVDataSet, DNSCacheManager, HeaderManager, HTTPFileArgs, JavaConfig, KeystoreConfig, LDAPArguments, LoginConfig, MongoSourceElement, RandomVariableConfig`

public class ConfigTestElement extends AbstractTestElement implements Serializable, ConfigElement

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`PASSWORD`
`static final String`
`USERNAME`

### Fields inherited from interface TestElement

`COMMENTS, ENABLED, GUI_CLASS, NAME, TEST_CLASS`

## Constructor Summary

Constructors
Constructor
Description
`ConfigTestElement()`

## Method Summary

Modifier and Type
Method
Description
`void`
`addConfigElement(ConfigElement config)`
Add a configuration element to this one.
`void`
`addTestElement(TestElement parm1)`
`boolean`
`expectsModification()`
If your config element expects to be modified in the process of a test run, and you want those modifications to carry over from sample to sample (as in a cookie manager - you want to save all cookies that get set throughout the test), then return true for this method.

### Methods inherited from class AbstractTestElement

`addPropertiesValues, addProperty, addProperty, canRemove, clear, clearTemporary, clearTestElementChildren, clone, emptyTemporary, equals, getComment, getName, getProperty, getPropertyAsBoolean, getPropertyAsBoolean, getPropertyAsDouble, getPropertyAsFloat, getPropertyAsInt, getPropertyAsInt, getPropertyAsLong, getPropertyAsLong, getPropertyAsString, getPropertyAsString, getSearchableTokens, getThreadContext, getThreadName, hashCode, isEnabled, isRunningVersion, isTemporary, logProperties, mergeIn, propertyIterator, recoverRunningVersion, removeProperty, setComment, setEnabled, setName, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setRunningVersion, setTemporary, setThreadContext, setThreadName, traverse, traverseCollection, traverseMap, traverseProperty`

### Methods inherited from class Object

`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface ConfigElement

`clone`

## Field Details

### USERNAME

public static final String USERNAME

See Also:
  - Constant Field Values

### PASSWORD

public static final String PASSWORD

See Also:
  - Constant Field Values

## Constructor Details

### ConfigTestElement

public ConfigTestElement()

## Method Details

### addTestElement

public void addTestElement(TestElement parm1)
Description copied from class: `AbstractTestElement`

Specified by:
  `addTestElement` in interface `TestElement`
Overrides:
  `addTestElement` in class `AbstractTestElement`

### addConfigElement

public void addConfigElement(ConfigElement config)
Add a configuration element to this one. This allows config elements to combine and give a "layered" effect. For example, HTTPConfigElements have properties for domain, path, method, and parameters. If element A has everything filled in, but null for domain, and element B is added, which has only domain filled in, then after adding B to A, A will have the domain from B. If A already had a domain, then the correct behavior is for A to ignore the addition of element B.

Specified by:
  `addConfigElement` in interface `ConfigElement`
Parameters:
  `config` - the element to be added to this ConfigElement

### expectsModification

public boolean expectsModification()
If your config element expects to be modified in the process of a test run, and you want those modifications to carry over from sample to sample (as in a cookie manager - you want to save all cookies that get set throughout the test), then return true for this method. Your config element will not be cloned for each sample. If your config elements are more static in nature, return false. If in doubt, return false.

Specified by:
  `expectsModification` in interface `ConfigElement`
Returns:
  true if the element expects to be modified over the course of a test run